/*ALIAS>prop_db*/

/*SQLStart>1460*/
alter table invoices
  add IN_RKONum numeric(15, 2);
/*SQLStop>1460*/

/*SQLStart>1461*/
ALTER PROCEDURE CLEARBADINVOICES
AS
DECLARE VARIABLE inid integer;
begin
  for select IN_ID from invoices
    where (IN_InvoiceNum is null) and (IN_PKONum is null) and (IN_PKWNum is null) and (IN_RKONum is null) and ((IN_BONum is null) or (IN_BONum = -1)) 
  into :inid
  do
  begin
    delete from DayPayments where dp_inid = :inid;
    delete from InDetail where id_id = :inid;
    delete from Invoices where in_id = :inid; 
  end

  delete from daypayments where (dp_credit+dp_debit+dp_saldo) = 0;
  delete from Payment where p_flag = -1;
  exit;
end
/*SQLStop>1461*/

/*SQLStart>1462*/
create procedure CreateRKOCounters
as
declare variable dcid integer;
begin
  for select dch_id from DOCCOUNTHEADER
     into :dcid
  do begin
    insert into doccounts (dc_id, dc_text, dc_doctype, dc_count) values (:dcid, "  ", 8, 0);
  end
end;
/*SQLStop>1462*/

/*SQLStart>1463*/
execute procedure CreateRKOCounters
/*SQLStop>1463*/

/*SQLStart>1464*/
drop procedure CreateRKOCounters
/*SQLStop>1464*/

/*SQLStart>1465*/
alter table DayFinish
  add DF_RKO_INID integer;
/*SQLStop>1465*/

/*SQLStart>1466*/
update  DayFinish
  set DF_RKO_INID = 0;
/*SQLStop>1466*/

/*SQLStart>1467*/
create index DFRKOINID_INDEX on DayFinish(DF_RKO_INID);
/*SQLStop>1467*/

/*SQLStart>1468*/
alter table DayFinish
  add DF_ANULED smallint default 0,
  add DF_ANULDATE date,
  add DF_ANULREASON varchar(100);
/*SQLStop>1468*/

/*SQLStart>1469*/
update DayFinish
  set DF_ANULED = 0;
/*SQLStop>1469*/