/*ALIAS>prop_db*/

/*SQLStart>1508*/
/*ALTER TABLE persons ALTER per_obshtina TYPE VARCHAR(25);*/
UPDATE RDB$FIELDS SET RDB$FIELD_LENGTH=240, RDB$CHARACTER_LENGTH=240
  WHERE RDB$FIELD_NAME=(SELECT RDB$FIELD_SOURCE FROM RDB$RELATION_FIELDS
  WHERE RDB$RELATION_NAME='Persons' AND  RDB$FIELD_NAME='per_obshtina');
/*SQLStop>1508*/

/*SQLStart>1509*/
/*ALTER TABLE ul_kl ALTER ul_text TYPE VARCHAR(80);*/
UPDATE RDB$FIELDS SET RDB$FIELD_LENGTH=240, RDB$CHARACTER_LENGTH=240 
 WHERE RDB$FIELD_NAME=(SELECT RDB$FIELD_SOURCE FROM RDB$RELATION_FIELDS
 WHERE RDB$RELATION_NAME='ul_kl' AND  RDB$FIELD_NAME='ul_text');
/*SQLStop>1509*/

/*SQLStart>1510*/
/* zaradi dvete udyljeni poleta... */

ALTER PROCEDURE PERSONADD(
    PERNAME VARCHAR(75),
    PERTYPE SMALLINT,
    PEREGN VARCHAR(15),
    PERPDATA VARCHAR(15),
    PEREMAIL VARCHAR(50),
    PERCOMENT VARCHAR(150),
    PERNM VARCHAR(30),
    PERADDR VARCHAR(250),
    PERTELEFON VARCHAR(25),
    PERFALGPASS CHAR(1),
    PEROBSHTINA VARCHAR(25),
    PEROBLAST VARCHAR(25),
    PERFAX VARCHAR(25),
    PERPK VARCHAR(5))
RETURNS (
    PERID INTEGER,
    RESULT CHAR(1))
AS
BEGIN
/* proc-a wrashta PerID na wece waweden person ili na insertnatiq, 
   Result = F -> znachi wece go e imalo
   Result = N -> znachi ei sega e bil insertnat
*/
  if ((PerEGN is null) or (PerEGN = ""))then
  begin
    select Per_ID
      from persons
      where 
        Per_Flag = 'T' and
        AClearStr(Per_Name) = AClearStr(:PerName) and
        AClearStr(Per_NM) = AClearStr(:PerNM)
      into PerID;
  end
  else
  begin
    select Per_ID
      from persons
      where 
        Per_Flag = 'T' and
        Per_EGN = :PerEGN
      into PerID;
  end
  RESULT = 'F';
  if (:PerID is null) then
  begin
    insert into Persons(PER_NAME, PER_TYPE, PER_EGN, PER_PDATA, PER_EMAIL,
                        PER_COMENT, PER_NM, PER_ADDR, PER_TELEFON,PER_FlagPass,
                        PER_OBSHTINA, PER_OBLAST, PER_FAX, PER_FLAG, PER_PK)
    values (:PERNAME, :PERTYPE, :PEREGN, :PERPDATA, :PEREMAIL,
                        :PERCOMENT, :PERNM, :PERADDR, :PERTELEFON, :PERFALGPASS,
                        :PEROBSHTINA, :PEROBLAST, :PERFAX, 'T', :PERPK);
    PerID = GEN_ID(PER_ID_GEN, 0);
    RESULT = 'T';
  end
  suspend;
END
/*SQLStop>1510*/

/*SQLStart>1511*/
/* pak zaradi udyljenite poleta... */
ALTER PROCEDURE FIRMADD(
    PERNAME VARCHAR(75),
    PERTYPE SMALLINT,
    PEREGN VARCHAR(15),
    PEREMAIL VARCHAR(50),
    PERCOMENT VARCHAR(150),
    PERNM VARCHAR(30),
    PERADDR VARCHAR(250),
    PERTELEFON VARCHAR(25),
    PERDANN VARCHAR(10),
    PERSAD VARCHAR(40),
    PERFIRMDELO VARCHAR(40),
    PERDATEREG DATE,
    PEROBSHTINA VARCHAR(25),
    PEROBLAST VARCHAR(25),
    PERFAX VARCHAR(25),
    PERMOL INTEGER,
    PERPK VARCHAR(5),
    PERINDDS VARCHAR(15),
    PERADDRCORESP VARCHAR(250),
    PERTDNAP VARCHAR(20),
    PERTDNAPADDR VARCHAR(50))
RETURNS (
    PERID INTEGER,
    RESULT CHAR(1))
AS
begin
/* proc-a wrashta PerID na wece waweden person ili na insertnatiq, 
   Result = F -> znachi wece go e imalo
   Result = N -> znachi ei sega e bil insertnat
*/
  select per_id 
    from persons
    where 
      Per_Flag = 'F' and 
      Per_EGN = :PerEGN
    into PerID;
  RESULT = 'F'; 
  if (PerID is null) then
  begin
    insert into persons(PER_NAME, PER_TYPE, PER_EGN, PER_EMAIL,
                        PER_COMENT, PER_NM, PER_ADDR, PER_TELEFON,
                        PER_DANN, PER_SAD, PER_FIRMDELO, PER_DATEREG,
                        PER_OBSHTINA, PER_OBLAST, PER_FAX, PER_MOL, PER_FLAG, PER_PK, PER_INDDS, 
                        PER_ADDR_CORESP, PER_TDNAP, PER_TDNAP_ADDR)
    values (:PERNAME, :PERTYPE, :PEREGN, :PEREMAIL,
                        :PERCOMENT, :PERNM, :PERADDR, :PERTELEFON,
                        :PERDANN, :PERSAD, :PERFIRMDELO, :PERDATEREG,
                        :PEROBSHTINA, :PEROBLAST, :PERFAX, :PERMOL, 'F', :PERPK, :PERINDDS,
                        :PERADDRCORESP, :PERTDNAP, :PERTDNAPADDR);
    PerID = GEN_ID(PER_ID_GEN, 0);
    RESULT = 'N';
  end
  suspend; 
end
/*SQLStop>1511*/

/*SQLStart>1512*/
/*       */
UPDATE RDB$FIELDS SET RDB$FIELD_LENGTH=240, RDB$CHARACTER_LENGTH=240
  WHERE RDB$FIELD_NAME=(SELECT RDB$FIELD_SOURCE FROM RDB$RELATION_FIELDS
  WHERE RDB$RELATION_NAME='DOCUMENTS' AND  RDB$FIELD_NAME='DOC_Compound');
/*SQLStop>1512*/