/*ALIAS>prop_db*/

/*SQLStart>2635*/
CREATE TABLE BANK_KL (
    BANK_ID        INTEGER NOT NULL,
    BANK_BANKNAME  VARCHAR(50),
    BANK_SHORTNAME  VARCHAR(10),
    BANK_BANKNAMELATIN VARCHAR(50),
    BANK_BANKSHORTNAMELATIN VARCHAR(10)
);	
/*SQLStop*/

/*SQLStart>2636*/
ALTER TABLE BANK_KL ADD CONSTRAINT PK_BANK_KL PRIMARY KEY (BANK_ID);
/*SQLStop*/

/*SQLStart>2637*/
GRANT ALL ON BANK_KL TO PUBLIC;
/*SQLStop*/

/*SQLStart>2638*/
CREATE GENERATOR BANK_ID_GEN;
/*SQLStop*/

/*SQLStart>2639*/
SET GENERATOR BANK_ID_GEN TO 0;
/*SQLStop*/

/*SQLStart>2640*/
CREATE OR ALTER trigger bank_kl_bi0 for bank_kl
active before insert position 0
AS
begin
  if (new.bank_id is null) then
    new.bank_id=gen_id(bank_id_gen, 1);
end
/*SQLStop*/

/*SQLStart>2641*/
ALTER TABLE bankaccinfo
ADD  BI_BANKID INTEGER;
/*SQLStop*/

/*SQLStart>2642*/
ALTER TABLE bankbranches
ADD BB_BANKID INTEGER;
/*SQLStop*/

/*SQLStart>2643*/
INSERT INTO bank_kl (bank_kl.bank_id,bank_kl.bank_bankname,bank_kl.bank_shortname,bank_kl.bank_banknamelatin,bank_kl.bank_bankshortnamelatin) VALUES(GEN_ID(bank_id_gen,1),'  ','','Bulgarian National Bank','BNB');
/*SQLStop*/

/*SQLStart>2644*/
INSERT INTO bank_kl (bank_kl.bank_id,bank_kl.bank_bankname,bank_kl.bank_shortname,bank_kl.bank_banknamelatin,bank_kl.bank_bankshortnamelatin) VALUES(GEN_ID(bank_id_gen,1),'  ','','UniCredit Bulbank','');
/*SQLStop*/

/*SQLStart>2645*/
INSERT INTO bank_kl (bank_kl.bank_id,bank_kl.bank_bankname,bank_kl.bank_shortname,bank_kl.bank_banknamelatin,bank_kl.bank_bankshortnamelatin) VALUES(GEN_ID(bank_id_gen,1),'  ','','DSK Bank','');
/*SQLStop*/

/*SQLStart>2646*/
INSERT INTO bank_kl (bank_kl.bank_id,bank_kl.bank_bankname,bank_kl.bank_shortname,bank_kl.bank_banknamelatin,bank_kl.bank_bankshortnamelatin) VALUES(GEN_ID(bank_id_gen,1),'   ','','United Bulgarian Bank','UBB');
/*SQLStop*/

/*SQLStart>2647*/
INSERT INTO bank_kl (bank_kl.bank_id,bank_kl.bank_bankname,bank_kl.bank_shortname,bank_kl.bank_banknamelatin,bank_kl.bank_bankshortnamelatin) VALUES(GEN_ID(bank_id_gen,1),'  ',' ','Eurobank Bulgaria','EB');
/*SQLStop*/

/*SQLStart>2648*/
INSERT INTO bank_kl (bank_kl.bank_id,bank_kl.bank_bankname,bank_kl.bank_shortname,bank_kl.bank_banknamelatin,bank_kl.bank_bankshortnamelatin) VALUES(GEN_ID(bank_id_gen,1),' ','','RaiffeisenBank','');
/*SQLStop*/

/*SQLStart>2649*/
INSERT INTO bank_kl (bank_kl.bank_id,bank_kl.bank_bankname,bank_kl.bank_shortname,bank_kl.bank_banknamelatin,bank_kl.bank_bankshortnamelatin) VALUES(GEN_ID(bank_id_gen,1),'   ',' ','Societe Generale Expressbank','SGE');
/*SQLStop*/

/*SQLStart>2650*/
INSERT INTO bank_kl (bank_kl.bank_id,bank_kl.bank_bankname,bank_kl.bank_shortname,bank_kl.bank_banknamelatin,bank_kl.bank_bankshortnamelatin) VALUES(GEN_ID(bank_id_gen,1),'   ',' ','Alliance Bank Bulgaria','');
/*SQLStop*/

/*SQLStart>2651*/
INSERT INTO bank_kl (bank_kl.bank_id,bank_kl.bank_bankname,bank_kl.bank_shortname,bank_kl.bank_banknamelatin,bank_kl.bank_bankshortnamelatin) VALUES(GEN_ID(bank_id_gen,1),'   ','','Piraeus Bank Bulgaria','');
/*SQLStop*/

/*SQLStart>2652*/
INSERT INTO bank_kl (bank_kl.bank_id,bank_kl.bank_bankname,bank_kl.bank_shortname,bank_kl.bank_banknamelatin,bank_kl.bank_bankshortnamelatin) VALUES(GEN_ID(bank_id_gen,1),'    ',' ','TBI Bank','TBI');
/*SQLStop*/

/*SQLStart>2653*/
INSERT INTO bank_kl (bank_kl.bank_id,bank_kl.bank_bankname,bank_kl.bank_shortname,bank_kl.bank_banknamelatin,bank_kl.bank_bankshortnamelatin) VALUES(GEN_ID(bank_id_gen,1),'   ',' ','First Investment Bank','Fibank');
/*SQLStop*/

/*SQLStart>2654*/
INSERT INTO bank_kl (bank_kl.bank_id,bank_kl.bank_bankname,bank_kl.bank_shortname,bank_kl.bank_banknamelatin,bank_kl.bank_bankshortnamelatin) VALUES(GEN_ID(bank_id_gen,1),' ','','CIBANK','');
/*SQLStop*/

/*SQLStart>2655*/
INSERT INTO bank_kl (bank_kl.bank_id,bank_kl.bank_bankname,bank_kl.bank_shortname,bank_kl.bank_banknamelatin,bank_kl.bank_bankshortnamelatin) VALUES(GEN_ID(bank_id_gen,1),'   ',' ','Commercial Bank Victoria','CBV');
/*SQLStop*/

/*SQLStart>2656*/
INSERT INTO bank_kl (bank_kl.bank_id,bank_kl.bank_bankname,bank_kl.bank_shortname,bank_kl.bank_banknamelatin,bank_kl.bank_bankshortnamelatin) VALUES(GEN_ID(bank_id_gen,1),' -    ',' ','Bulgarian-American Credit Bank','BACB');
/*SQLStop*/

/*SQLStart>2657*/
INSERT INTO bank_kl (bank_kl.bank_id,bank_kl.bank_bankname,bank_kl.bank_shortname,bank_kl.bank_banknamelatin,bank_kl.bank_bankshortnamelatin) VALUES(GEN_ID(bank_id_gen,1),'  ','','Procredit Bank','');
/*SQLStop*/

/*SQLStart>2658*/
INSERT INTO bank_kl (bank_kl.bank_id,bank_kl.bank_bankname,bank_kl.bank_shortname,bank_kl.bank_banknamelatin,bank_kl.bank_bankshortnamelatin) VALUES(GEN_ID(bank_id_gen,1),'   ','  ','DBank','');
/*SQLStop*/

/*SQLStart>2659*/
INSERT INTO bank_kl (bank_kl.bank_id,bank_kl.bank_bankname,bank_kl.bank_shortname,bank_kl.bank_banknamelatin,bank_kl.bank_bankshortnamelatin) VALUES(GEN_ID(bank_id_gen,1),'  ',' ','Tokuda Bank','');
/*SQLStop*/

/*SQLStart>2660*/
INSERT INTO bank_kl (bank_kl.bank_id,bank_kl.bank_bankname,bank_kl.bank_shortname,bank_kl.bank_banknamelatin,bank_kl.bank_bankshortnamelatin) VALUES(GEN_ID(bank_id_gen,1),' ','','IBank','');
/*SQLStop*/

/*SQLStart>2661*/
INSERT INTO bank_kl (bank_kl.bank_id,bank_kl.bank_bankname,bank_kl.bank_shortname,bank_kl.bank_banknamelatin,bank_kl.bank_bankshortnamelatin) VALUES(GEN_ID(bank_id_gen,1),'   ',' ','Central Cooperative Bank','');
/*SQLStop*/

/*SQLStart>2662*/
INSERT INTO bank_kl (bank_kl.bank_id,bank_kl.bank_bankname,bank_kl.bank_shortname,bank_kl.bank_banknamelatin,bank_kl.bank_bankshortnamelatin) VALUES(GEN_ID(bank_id_gen,1),'  ',' ','','');
/*SQLStop*/

/*SQLStart>2663*/
INSERT INTO bank_kl (bank_kl.bank_id,bank_kl.bank_bankname,bank_kl.bank_shortname,bank_kl.bank_banknamelatin,bank_kl.bank_bankshortnamelatin) VALUES(GEN_ID(bank_id_gen,1),'    ',' ','Bulgarian Development Bank','BDB');
/*SQLStop*/

/*SQLStart>2664*/
INSERT INTO bank_kl (bank_kl.bank_id,bank_kl.bank_bankname,bank_kl.bank_shortname,bank_kl.bank_banknamelatin,bank_kl.bank_bankshortnamelatin) VALUES(GEN_ID(bank_id_gen,1),'   ',' ','International Asset Bank','IAB');
/*SQLStop*/

/*SQLStart>2665*/
INSERT INTO bank_kl (bank_kl.bank_id,bank_kl.bank_bankname,bank_kl.bank_shortname,bank_kl.bank_banknamelatin,bank_kl.bank_bankshortnamelatin) VALUES(GEN_ID(bank_id_gen,1),'  ',' ','Texim Bank','');
/*SQLStop*/

/*SQLStart>2666*/
UPDATE bankaccinfo SET bankaccinfo.bi_bankid = 0;
/*SQLStop*/

/*SQLStart>2667*/
INSERT INTO system_strings (sys_id, sys_str) VALUES (1338,'0');
/*SQLStop*/

/*SQLStart>2668*/
UPDATE bankbranches SET bb_bankid = 0;
/*SQLStop*/

/*SQLStart>2669*/
INSERT INTO system_strings (sys_id,sys_str) VALUES(1305,'0');
/*SQLStop*/

/*SQLStart>2670*/
INSERT INTO system_strings (sys_id,sys_str) VALUES(1306,'0');
/*SQLStop*/

/*SQLStart>2671*/
update system_strings set sys_str = '6.7.215.1' where sys_id = 1401;  /*BackOffice*/
/*SQLStop*/
