/*ALIAS>prop_db*/

/*SQLStart>2777*/
create table TRANSACTIONS
(TR_ID INTEGER NOT NULL,
TR_UNIQUE_KEY VARCHAR(200),
TR_STARTDATE DATE,
TR_ENDTDATE DATE,
TR_VALUE NUMERIC(15, 2),
TR_STATE INTEGER,
TR_LOG BLOB SUB_TYPE 1 SEGMENT SIZE 4096,
constraint pk_transaction primary key(TR_ID));
/*SQLStop*/

/*SQLStart>2778*/
GRANT ALL ON TRANSACTIONS TO PUBLIC;
/*SQLStop*/

/*SQLStart>2779*/
CREATE GENERATOR TRANSACTION_ID_GEN;
/*SQLStop*/

/*SQLStart>2780*/
SET GENERATOR TRANSACTION_ID_GEN TO 0;
/*SQLStop*/

/*SQLStart>2781*/
create unique index ix_unique_key on TRANSACTIONS(TR_UNIQUE_KEY);
/*SQLStop*/

/*SQLStart>2782*/
CREATE table TRANSACTION_DOCUMENT
(TD_DOC_ID INTEGER NOT NULL,
TD_TRANSACTION_ID INTEGER NOT NULL,
td_value  NUMERIC(15,2),
constraint fk_trans_docs foreign key(TD_DOC_ID) references documents(doc_id),
constraint fk_transaction foreign key(TD_TRANSACTION_ID) references transactions(TR_ID));
/*SQLStop*/

/*SQLStart>2783*/
GRANT ALL ON TRANSACTION_DOCUMENT TO PUBLIC;
/*SQLStop*/

/*SQLStart>2784*/
alter table payment
add P_TRANSACTION_ID integer;
/*SQLStop*/


/*SQLStart>2785*/
CREATE TABLE LOCKS
(L_ID integer not null,
 L_TYPE VARCHAR(100) not null);
/*SQLStop*/

/*SQLStart>2786*/
ALTER TABLE LOCKS ADD PRIMARY KEY (L_ID, L_TYPE);
/*SQLStop*/

/*SQLStart>2787*/
GRANT ALL ON LOCKS TO PUBLIC;
/*SQLStop*/

/*SQLStart>2788*/
alter table doccounts
drop constraint PK_DOCCOUNTS;
/*SQLStop*/

/*SQLStart>2789*/
drop trigger DOCCOUNTS_BIU;
/*SQLStop*/

/*SQLStart>2790*/
ALTER TABLE doccounts
add DC_PK_ID INTEGER NOT NULL;
/*SQLStop*/

/*SQLStart>2791*/
ALTER TABLE DOCCOUNTS ADD CONSTRAINT PK_DC_PK_ID PRIMARY KEY (DC_PK_ID);
/*SQLStop*/

/*SQLStart>2792*/
ALTER TABLE DOCCOUNTS ADD CONSTRAINT UNQ_DOCCOUNTS UNIQUE (DC_ID, DC_DOCTYPE);
/*SQLStop*/

/*SQLStart>2793*/
CREATE GENERATOR DOCCOUNTS_ID_GEN;
/*SQLStop*/

/*SQLStart>2794*/
SET GENERATOR DOCCOUNTS_ID_GEN TO 0;
/*SQLStop*/

/*DLLStart>2795*/
DLLName=upd236.dll
DLLProc=SetDoccountsPrimaryKeys
/*DLLStop*/

/*SQLStart>2796*/
insert into users (user_id, user_unitid, user_str, user_name, user_active_kasa)
values (9999, 0, ' ', ' ', 1);
/*SQLStop*/

/*SQLStart>2797*/
update system_strings set sys_str = '6.7.236.1' where sys_id = 1401;
/*SQLStop*/